"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fetchModule = __importStar(require("./fetch"));
var Logger_1 = require("./Logger");
var interceptLogs = function () {
    var collection = [];
    jest.spyOn(fetchModule, 'fetch').mockImplementation(function (urlOrConfig, config) {
        var url = typeof urlOrConfig === 'string' ? urlOrConfig : urlOrConfig.url;
        var requestConfig = typeof urlOrConfig === 'string' ? config : urlOrConfig;
        var body = requestConfig && requestConfig.body;
        var stringBody = body && body.toString() || 'null';
        collection.push({
            url: url,
            requestConfig: requestConfig,
            logs: stringBody.split('\n').map(function (line) { return JSON.parse(line); }),
        });
        return Promise.resolve({});
    });
    return collection;
};
describe('Logger', function () {
    var logs;
    var expectToHaveLogged = function () {
        var expectedLogs = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            expectedLogs[_i] = arguments[_i];
        }
        expect(logs).toEqual(expectedLogs.map(function (log) {
            return expect.objectContaining({
                logs: log.map(function (groupedLog) { return expect.objectContaining({
                    event: expect.objectContaining(groupedLog),
                }); }),
            });
        }));
    };
    beforeEach(function () {
        logs = interceptLogs();
        jest.useFakeTimers();
    });
    afterEach(function () {
        jest.clearAllTimers();
        jest.useRealTimers();
    });
    var config = {
        splunkUrl: 'http://my-splunk-endpoint',
        authToken: 'MY-TOKEN',
        maxBuffer: 100,
        throttleDuration: 10000,
    };
    describe('create', function () {
        it('creates a logger with custom log types', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(config, 'fooLevel', 'barLevel');
                        logger.fooLevel('FOO');
                        logger.barLevel('BAR');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expectToHaveLogged([
                            { logType: 'fooLevel', eventName: 'FOO' },
                            { logType: 'barLevel', eventName: 'BAR' },
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
        it('creates a logger with the default log types', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(config);
                        logger.info('FOO');
                        logger.debug('BAR');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expectToHaveLogged([
                            { logType: 'info', eventName: 'FOO' },
                            { logType: 'debug', eventName: 'BAR' },
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('singleton', function () {
        afterEach(function () { return Logger_1.Logger.clearSingleton(); });
        it('returns the same logger each time', function () { return __awaiter(_this, void 0, void 0, function () {
            var loggerOne, loggerTwo;
            return __generator(this, function (_a) {
                loggerOne = Logger_1.Logger.singleton(config);
                loggerTwo = Logger_1.Logger.singleton(config);
                expect(loggerOne).toBe(loggerTwo);
                return [2 /*return*/];
            });
        }); });
        it('creates the default types', function () {
            var logger = Logger_1.Logger.singleton(config);
            logger.info('fooEvent');
            logger.flush();
            expectToHaveLogged([{ logType: 'info', eventName: 'fooEvent' }]);
        });
        it('can create a logger with custom log types', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.singleton(config, 'foo');
                        logger.foo('fooEvent');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expectToHaveLogged([{ logType: 'foo', eventName: 'fooEvent' }]);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('clearSingleton', function () {
        it('clears the singleton', function () { return __awaiter(_this, void 0, void 0, function () {
            var loggerOne, loggerTwo;
            return __generator(this, function (_a) {
                loggerOne = Logger_1.Logger.singleton(config);
                Logger_1.Logger.clearSingleton();
                loggerTwo = Logger_1.Logger.singleton(config);
                expect(loggerOne).not.toBe(loggerTwo);
                return [2 /*return*/];
            });
        }); });
    });
    describe('flush', function () {
        it('submits to the collector endpoint', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { splunkUrl: 'http://foo-bar' }));
                        logger.info('barEvent', { baz: 'bat' });
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expect(logs).toEqual([
                            expect.objectContaining({ url: 'http://foo-bar' }),
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
        it('authenticates with the hecToken', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { authToken: 'FOO-TOKEN' }));
                        logger.info('barEvent', { baz: 'bat' });
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expect(logs[0].requestConfig).toEqual(expect.objectContaining({ headers: { Authorization: 'Splunk FOO-TOKEN' } }));
                        return [2 /*return*/];
                }
            });
        }); });
        it('does not submit when buffer is empty', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { maxBuffer: 2 }));
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expect(logs).toHaveLength(0);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('logging', function () {
        it('serializes the details immediately so later mutations do not affect older logs', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger, details;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(config);
                        details = { foo: 'foo' };
                        logger.info('one', details);
                        details.foo = 'new foo';
                        logger.info('two', details);
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expectToHaveLogged([
                            { eventName: 'one', foo: 'foo' },
                            { eventName: 'two', foo: 'new foo' },
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
        it('incudes static splunkMeta properties', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { splunkMeta: { time: 123, host: 'my host' } }));
                        logger.info('foo');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expect(logs[0].logs[0]).toEqual(expect.objectContaining({
                            time: 123, host: 'my host',
                        }));
                        return [2 /*return*/];
                }
            });
        }); });
        it('provides a timestamp with <sec>.<ms> by default', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        jest.spyOn(Date, 'now').mockReturnValue(12345);
                        logger = Logger_1.Logger.create(config);
                        logger.info('foo');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expect(logs[0].logs[0]).toEqual(expect.objectContaining({
                            time: 12.345,
                        }));
                        return [2 /*return*/];
                }
            });
        }); });
        it('incudes dynamic splunkMeta properties', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { splunkMeta: function () { return ({ time: 123, host: 'my host' }); } }));
                        logger.info('foo');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expect(logs[0].logs[0]).toEqual(expect.objectContaining({
                            time: 123, host: 'my host',
                        }));
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('interceptors', function () {
        it('modifies the outgoing log details with intercept return', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { interceptor: function (originalDetails) { return (__assign({}, originalDetails, { newDetails: 'bar' })); } }));
                        logger.info('one', { originalDetails: 'foo' });
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expectToHaveLogged([
                            { eventName: 'one', originalDetails: 'foo', newDetails: 'bar' },
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
        it('can be set after the logger is created', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(config);
                        logger.interceptor = function (originalDetails) { return (__assign({}, originalDetails, { newDetails: 'bar' })); };
                        logger.info('one', { originalDetails: 'foo' });
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expectToHaveLogged([
                            { eventName: 'one', originalDetails: 'foo', newDetails: 'bar' },
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('buffering', function () {
        it('automatically flushes logs when the buffer is full', function () {
            var logger = Logger_1.Logger.create(__assign({}, config, { maxBuffer: 3 }));
            logger.info('group1:one');
            logger.info('group1:two');
            logger.info('group1:three');
            // Buffer max hit
            logger.info('group2:four');
            logger.info('group2:five');
            logger.info('group2:six');
            expectToHaveLogged([
                { eventName: 'group1:one' },
                { eventName: 'group1:two' },
                { eventName: 'group1:three' },
            ], [
                { eventName: 'group2:four' },
                { eventName: 'group2:five' },
                { eventName: 'group2:six' },
            ]);
        });
    });
    describe('throttling', function () {
        it('automatically flushes logs when the the throttleDuration is met', function () {
            var logger = Logger_1.Logger.create(__assign({}, config, { throttleDuration: 2000, maxBuffer: 3 }));
            logger.info('one');
            logger.info('two');
            jest.advanceTimersByTime(2001);
            expectToHaveLogged([
                { eventName: 'one' },
                { eventName: 'two' },
            ]);
        });
        it('does not log before the buffer is full or the duration is met', function () {
            var logger = Logger_1.Logger.create(__assign({}, config, { throttleDuration: 2000, maxBuffer: 3 }));
            logger.info('nope:one');
            logger.info('nope:two');
            jest.advanceTimersByTime(1000);
            expect(logs).toHaveLength(0);
        });
        it('resets the timer when a new log entry is made', function () {
            var logger = Logger_1.Logger.create(__assign({}, config, { throttleDuration: 2000, maxBuffer: 3 }));
            logger.info('nope:one');
            jest.advanceTimersByTime(1500);
            logger.info('nope:two');
            jest.advanceTimersByTime(1500);
            expect(logs).toHaveLength(0);
        });
        it('resets the timer when flushed', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { throttleDuration: 2000, maxBuffer: 3 }));
                        logger.info('yup:one');
                        logger.info('yup:two');
                        jest.advanceTimersByTime(1000);
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        logger.info('nope:one'); // Should not be logged yet
                        jest.advanceTimersByTime(1900);
                        expectToHaveLogged([
                            { eventName: 'yup:one' },
                            { eventName: 'yup:two' },
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('autoRetry', function () {
        it('retries the flush when fetch fails', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { autoRetryDuration: 1000 }));
                        jest.spyOn(fetchModule, 'fetch').mockRejectedValueOnce('Oops, no network!');
                        logger.info('yup:one');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        logs.length = 0;
                        jest.advanceTimersByTime(1000);
                        expectToHaveLogged([
                            { eventName: 'yup:one' },
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
        it('stops retrying when fetch succeeds', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { autoRetryDuration: 1000 }));
                        jest.spyOn(fetchModule, 'fetch').mockRejectedValueOnce('Oops, no network!');
                        logger.info('yup:one');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        logs.length = 0;
                        jest.advanceTimersByTime(1000);
                        jest.advanceTimersByTime(1000);
                        jest.advanceTimersByTime(1000);
                        expectToHaveLogged([
                            { eventName: 'yup:one' },
                        ]);
                        return [2 /*return*/];
                }
            });
        }); });
        it('does not retry when autoRetry is false', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { autoRetry: false, autoRetryDuration: 1000 }));
                        jest.spyOn(fetchModule, 'fetch').mockRejectedValueOnce('Oops, no network!');
                        logger.info('yup:one');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        logs.length = 0;
                        jest.advanceTimersByTime(1000);
                        return [4 /*yield*/, Promise.resolve()];
                    case 2:
                        _a.sent();
                        expect(logs).toHaveLength(0);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('disabled', function () {
        it('does not log when disabled in the confg', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { enabled: false }));
                        logger.info('nope');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expect(logs).toHaveLength(0);
                        return [2 /*return*/];
                }
            });
        }); });
        it('does not log when disabled after creation', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { enabled: true }));
                        logger.disable();
                        logger.info('nope');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expect(logs).toHaveLength(0);
                        return [2 /*return*/];
                }
            });
        }); });
        it('does not intercept logs when disabled', function () { return __awaiter(_this, void 0, void 0, function () {
            var interceptor, logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        interceptor = jest.fn();
                        logger = Logger_1.Logger.create(__assign({}, config, { enabled: false, interceptor: interceptor }));
                        logger.info('nope');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expect(interceptor).not.toHaveBeenCalled();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('enabled', function () {
        it('logs when enabled after creation', function () { return __awaiter(_this, void 0, void 0, function () {
            var logger;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger = Logger_1.Logger.create(__assign({}, config, { enabled: false }));
                        logger.enable();
                        logger.info('yup');
                        return [4 /*yield*/, logger.flush()];
                    case 1:
                        _a.sent();
                        expectToHaveLogged([{ eventName: 'yup' }]);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('logToConsole', function () {
        beforeEach(function () {
            jest.spyOn(console, 'log').mockImplementation(function () { return undefined; });
        });
        describe('enabled', function () {
            it('logs to the console', function () { return __awaiter(_this, void 0, void 0, function () {
                var logger;
                return __generator(this, function (_a) {
                    logger = Logger_1.Logger.create(__assign({}, config, { logToConsole: true }));
                    logger.info('yup', { my: 'details' });
                    expect(console.log) // tslint:disable-line no-console
                        .toHaveBeenCalledWith('info', 'yup', { my: 'details' });
                    return [2 /*return*/];
                });
            }); });
            it('logs to the console even when the logger is disabled', function () { return __awaiter(_this, void 0, void 0, function () {
                var logger;
                return __generator(this, function (_a) {
                    logger = Logger_1.Logger.create(__assign({}, config, { enabled: false, logToConsole: true }));
                    logger.info('yup', { my: 'details' });
                    expect(console.log) // tslint:disable-line no-console
                        .toHaveBeenCalledWith('info', 'yup', { my: 'details' });
                    return [2 /*return*/];
                });
            }); });
        });
        describe('disabled', function () {
            it('does not log to the console', function () { return __awaiter(_this, void 0, void 0, function () {
                var logger;
                return __generator(this, function (_a) {
                    logger = Logger_1.Logger.create(__assign({}, config, { logToConsole: false }));
                    logger.info('yup', { my: 'details' });
                    expect(console.log).not.toHaveBeenCalled(); // tslint:disable-line no-console
                    return [2 /*return*/];
                });
            }); });
        });
    });
});
